# include "HAnalysisHiggsCpv.hh"

hhiggscpv::HAnalysis::HAnalysis()
{

//     DebugLevel = hanalysis::HObject::HDebug;
    Print(HNotification, "Constructor");
    //JetTag = new hanalysis::HJetTag();

}

hhiggscpv::HAnalysis::~HAnalysis()
{

    Print(HNotification, "Destructor");

    //delete JetTag;

//     if (!BottomTagger)delete BottomTagger;
//     if (!LeptonicTopTagger) delete LeptonicTopTagger;
//     if (!HiggsTagger) delete HiggsTagger;
//     if (!LeptonicTopTagger) delete LeptonicTopTagger;

//     if (!BottomReader) delete BottomReader;
//     if (!HiggsReader) delete HiggsReader;

}

HStrings hhiggscpv::HAnalysis::GetStudyNames(const HTagger Tagger)
{
    Print(HNotification, "Get Study Names", Tagger);

//     Tagger = NewTagger;

    if (Tagger == HBottomTagger) {
        return {"Bottom", "NotBottom"};
    } else if (Tagger == HTopLeptonicTagger) {
        return  {"Top", "NotTop"};
    } else if (Tagger == HHiggsLeptonicTagger) {
        return  {"Higgs", "NotHiggs"};
    } else if (Tagger == HEventTagger) {
        return  {"Signal", "Background"};
    } else {
        Print(HError, "unexpected TaggerName", Tagger);
        return {};
    }
}

std::vector<hanalysis::HFile *> hhiggscpv::HAnalysis::GetFiles(const std::string &NewStudyName)
{
    Print(HNotification, "Set File Vector", NewStudyName);

    std::vector<hanalysis::HFile *> files;

//     hdelphes::HFile *Test3 = new hdelphes::HFile("pp-hz-bbvv", "signal");
//     Files.push_back(Test3);
//     return Files;

    if (NewStudyName != "Higgs" && NewStudyName != "Signal") {

//     hdelphes::HFile *Test4 = new hdelphes::HFile("pp-bbz-bbvv", "background");
        //     Files.push_back(Test4);

//     hdelphes::HFile *Test2 = new hdelphes::HFile("pp-bbjj");
        //     Files.push_back(Test2);


      hanalysis::hdelphes::HFile *Background = new hanalysis::hdelphes::HFile("pp-bbtt-bblvlv", "background");
        Background->SetCrosssection(3.215); // pb
        Background->SetError(0.012); // pb
        files.push_back(Background);

    }

    hanalysis::hdelphes::HFile *Even = new hanalysis::hdelphes::HFile("pp-x0tt-bblvlv", "even");
    Even->SetCrosssection(30.02079); // pb
    Even->SetError(0.000078); // pb
//     Even->TagString="tag_2";
    files.push_back(Even);

    hanalysis::hdelphes::HFile *Mix = new hanalysis::hdelphes::HFile("pp-x0tt-bblvlv", "mix");
    Mix->SetCrosssection(30.01172); // pb
    Mix->SetError(0.000045); // pb
//     Mix->TagString="tag_2";
    files.push_back(Mix);

    hanalysis::hdelphes::HFile *Odd = new hanalysis::hdelphes::HFile("pp-x0tt-bblvlv", "odd");
    Odd->SetCrosssection(30.008951); // pb
    Odd->SetError(0.000035); // pb
//     Odd->TagString="tag_2";
    files.push_back(Odd);

//     hdelphes::HFile *Test = new hdelphes::HFile("pp-hjj-bbjj");
//     Files.push_back(Test);
//     hdelphes::HFile *Signal = new hdelphes::HFile("pp-htt-bblvlv", "signal");
//     Signal->Crosssection = 0.01419; // pb
//     Signal->Error = 0.000067; // pb
// //     Odd->TagString="tag_2";
//     Files.push_back(Signal);

    Print(HNotification, "Files prepared");




    BottomTagger = hanalysis::HBottomTagger();
    BottomTagger.SetAnalysisName(ProjectName());
//     BottomTagger.SetTestTreeNames( {"pp-bbtt-bblvlv-background", "pp-x0tt-bblvlv-even", "pp-x0tt-bblvlv-mix", "pp-x0tt-bblvlv-odd"});
    BottomTagger.SetSignalTreeNames( {"pp-bbtt-bblvlv-background", "pp-x0tt-bblvlv-even", "pp-x0tt-bblvlv-mix", "pp-x0tt-bblvlv-odd"});
    BottomTagger.SetBackgroundTreeNames( {"pp-bbtt-bblvlv-background", "pp-x0tt-bblvlv-even", "pp-x0tt-bblvlv-mix", "pp-x0tt-bblvlv-odd"});

    if (NewStudyName != "Bottom" && NewStudyName != "NotBottom") {

      BottomReader.SetMva(BottomTagger);

      LeptonicTopTagger = hanalysis::HTopLeptonicTagger(BottomTagger);
        LeptonicTopTagger.SetAnalysisName(ProjectName());
//         LeptonicTopTagger.SetTestTreeNames( {"pp-bbtt-bblvlv-background", "pp-x0tt-bblvlv-even", "pp-x0tt-bblvlv-mix", "pp-x0tt-bblvlv-odd"});
        LeptonicTopTagger.SetSignalTreeNames( {"pp-bbtt-bblvlv-background", "pp-x0tt-bblvlv-even", "pp-x0tt-bblvlv-mix", "pp-x0tt-bblvlv-odd"});
        LeptonicTopTagger.SetBackgroundTreeNames( {"pp-bbtt-bblvlv-background", "pp-x0tt-bblvlv-even", "pp-x0tt-bblvlv-mix", "pp-x0tt-bblvlv-odd"});



        HiggsTagger = hanalysis::HMvaHiggsTagger(BottomTagger);
        HiggsTagger.SetAnalysisName(ProjectName());
//         HiggsTagger.SetTestTreeNames( {"pp-bbtt-bblvlv-background", "pp-x0tt-bblvlv-even", "pp-x0tt-bblvlv-mix", "pp-x0tt-bblvlv-odd"});
        HiggsTagger.SetSignalTreeNames( {"pp-x0tt-bblvlv-even", "pp-x0tt-bblvlv-mix", "pp-x0tt-bblvlv-odd"});
        HiggsTagger.SetBackgroundTreeNames( {"pp-bbtt-bblvlv-background", "pp-x0tt-bblvlv-even", "pp-x0tt-bblvlv-mix", "pp-x0tt-bblvlv-odd"});

        if (NewStudyName != "Top" && NewStudyName != "NotTop" && NewStudyName != "Higgs" && NewStudyName != "NotHiggs") {
          HiggsReader.SetMva(HiggsTagger);
          TopReader.SetMva(LeptonicTopTagger);
        }

    }

    return files;

}


void hhiggscpv::HAnalysis::NewBranches(ExRootTreeWriter *NewTreeWriter, const HTagger Tagger)
{
    Print(HNotification, "New Branches", Tagger);

    if (Tagger == HBottomTagger) {
        BottomBranch = NewTreeWriter->NewBranch("Bottom", HBottomBranch::Class());
    } else if (Tagger == HTopLeptonicTagger) {
        TopBranch = NewTreeWriter->NewBranch("Top", HTopLeptonicBranch::Class());
    } else if (Tagger == HHiggsLeptonicTagger) {
        HiggsBranch = NewTreeWriter->NewBranch("Higgs", HHiggsBranch::Class());
        ConstituentBranch = NewTreeWriter->NewBranch("Constituent", HParticleBranch::Class());
    } else if (Tagger == HEventTagger) {
        EventBranch = NewTreeWriter->NewBranch("Event", HEventBranch::Class());
    }
//     } else {
//         ConstituentBranch = TreeWriter->NewBranch("Constituent", HParticleBranch::Class());
}

bool hhiggscpv::HAnalysis::Analysis(hanalysis::HEvent &Event, const std::string &NewStudyName, const HTagger Tagger)
{

    Print(HInformation, "Analysis", NewStudyName);

    if (Tagger == HBottomTagger) {
        if (GetBottomTag(Event, NewStudyName)) return 1;
    } else if (Tagger == HTopLeptonicTagger) {
        if (GetTopTag(Event, NewStudyName)) return 1;
    } else if (Tagger == HHiggsLeptonicTagger) {
        if (GetHiggsTag(Event, NewStudyName)) return 1;
    } else if (Tagger == HEventTagger) {
        if (GetSignalTag(Event, NewStudyName)) return 1;
    } else {
        Print(HError, "unknown Tagger", Tagger);
    }

    return 0;

}


bool hhiggscpv::HAnalysis::GetBottomTag(hanalysis::HEvent &, const std::string &NewStudyName)
{

    Print(HDebug, "Get Bottom Tag", NewStudyName);

//     HTag State;
//     if (StudyName == "Bottom") State = HSignal;
//     if (StudyName == "NotBottom") State = HBackground;

//     std::vector<HBottomBranch *> Bottoms = BottomTagger.GetBranches(Event, State);
//
//     for (const auto & Bottom : Bottoms) {
//         HBottomBranch *BTagger = static_cast<HBottomBranch *>(BottomBranch->NewEntry());
//         *BTagger = *Bottom;
//     }

    return 1;

}


bool hhiggscpv::HAnalysis::GetTopTag(hanalysis::HEvent &Event, const std::string &NewStudyName)
{

    Print(HInformation, "Get Tops", NewStudyName);

    HTag State;
    if (NewStudyName == "Top") State = HSignal;
    if (NewStudyName == "NotTop") State = HBackground;

    std::vector<HTopLeptonicBranch> Tops = LeptonicTopTagger.GetBranches(Event, State);

    for (const auto & Top : Tops) *static_cast<HTopLeptonicBranch *>(TopBranch->NewEntry()) = Top;

    return 1;

}


bool hhiggscpv::HAnalysis::GetHiggsTag(hanalysis::HEvent &Event, const std::string &NewStudyName)
{
    Print(HInformation, "Get Higgs Tag", NewStudyName);

    HTag State;
    if (NewStudyName == "Higgs") State = HSignal;
    if (NewStudyName == "NotHiggs") State = HBackground;

    std::vector<HHiggsBranch *> Higgses = HiggsTagger.GetBranches(Event, State);

    for (const auto & Higgs : Higgses) {
        HHiggsBranch *HiggsBranch1 = static_cast<HHiggsBranch *>(HiggsBranch->NewEntry());
        *HiggsBranch1 = *Higgs;
    }

    std::vector<HParticleBranch *> Constitents = HiggsTagger.GetConstituentBranches();

    for (const auto & Constituent : Constitents) {
        HParticleBranch *ConstituentBranch1 = static_cast<HParticleBranch *>(ConstituentBranch->NewEntry());
        *ConstituentBranch1 = *Constituent;
    }

    return 1;

}


struct SortHiggsCpv {
    inline bool operator()(const HHiggsCpv &Event1, const HHiggsCpv &Event2) {
        return (Event1.Bdt() > Event2.Bdt());
    }
};

bool hhiggscpv::HAnalysis::GetSignalTag(hanalysis::HEvent &Event, const std::string &NewStudyName)
{
    Print(HInformation, "Get Event", NewStudyName);

    HJets Leptons = Event.GetLeptons()->GetLeptonJets();
    if (Leptons.size() < 2) {
        Print(HNotification, "Not enough Leptons", Leptons.size());
        return 0;
    }

    HJets Jets = Event.GetJets()->GetStructuredJets();
    if (Jets.size() < 4) {
        Print(HNotification, "Not enough Jets", Jets.size());
        return 0;

    }

    for (auto & Jet : Jets) {
        hanalysis::HJetInfo *JetInfo = new hanalysis::HJetInfo;
//         BottomTagger.Branch = BottomTagger.GetBranch(Jet); // FIXME reenable this
        JetInfo->SetBdt(BottomReader.Bdt());
        Jet.set_user_info(JetInfo);
    }

    std::vector<HHiggsCpv> HiggsCpvs;
    for (HJets::iterator Lepton1 = Leptons.begin(); Lepton1 != Leptons.end(); ++Lepton1) {
        for (HJets::iterator Lepton2 = Lepton1 + 1; Lepton2 != Leptons.end(); ++Lepton2) {
            const HJets EventLeptons {
                (*Lepton1), (*Lepton2)
            };
            for (HJets::iterator Jet1 = Jets.begin(); Jet1 != Jets.end(); ++Jet1) {
                for (HJets::iterator Jet2 = Jet1 + 1; Jet2 != Jets.end(); ++Jet2) {
                    for (HJets::iterator Jet3 = Jet2 + 1; Jet3 != Jets.end(); ++Jet3) {
                        for (HJets::iterator Jet4 = Jet3 + 1; Jet4 != Jets.end(); ++Jet4) {
                            const HJets EventJets = {(*Jet1), (*Jet2), (*Jet3), (*Jet4)};
                            std::vector<HHiggsCpv> NewHiggsCpvs = GetHiggsCpvs(EventJets, EventLeptons);
                            HiggsCpvs.insert(HiggsCpvs.end(), NewHiggsCpvs.begin(), NewHiggsCpvs.end());
                        }
                    }
                }
            }
        }
    }

    std::sort(HiggsCpvs.begin(), HiggsCpvs.end(), SortHiggsCpv());

    HEventBranch *EventTagger = static_cast<HEventBranch *>(EventBranch->NewEntry());

    EventTagger->ScalarHt = Event.GetJets()->GetScalarHt();
    EventTagger->JetNumber = Event.GetJets()->GetJets().size();
    EventTagger->BottomNumber = Event.GetJets()->GetBottomJets().size();
    EventTagger->LeptonNumber = Event.GetLeptons()->GetLeptonJets().size();
    EventTagger->HeavyParticleTag = HiggsCpvs.front().Bdt();
    EventTagger->TopDeltaRap = HiggsCpvs.front().GetTopDeltaRap();
    EventTagger->TopDeltaPhi = HiggsCpvs.front().GetTopDeltaPhi();
    EventTagger->TopDeltaR = HiggsCpvs.front().GetTopDeltaR();
    if (NewStudyName == "Signal") {
        EventTagger->Signal = 1;
    } else {
        EventTagger->Signal = 0;
    }

    return 1;

}

std::vector< HHiggsCpv > hhiggscpv::HAnalysis::GetHiggsCpvs(const HJets &Jets, const HJets &Leptons)
{

    std::vector<HHiggsCpv> HiggsCpvs;

    hanalysis::HDoublet HiggsPair01 = hanalysis::HDoublet(Jets[0], Jets[1]);
    HiggsTagger.FillBranch(HiggsPair01);
    HiggsPair01.SetBdt(HiggsReader.Bdt());
    hanalysis::HDoublet HiggsPair02 = hanalysis::HDoublet(Jets[0], Jets[2]);
    HiggsTagger.FillBranch(HiggsPair02);
    HiggsPair02.SetBdt(HiggsReader.Bdt());
    hanalysis::HDoublet HiggsPair03 = hanalysis::HDoublet(Jets[0], Jets[3]);
    HiggsTagger.FillBranch(HiggsPair03);
    HiggsPair03.SetBdt(HiggsReader.Bdt());
    hanalysis::HDoublet HiggsPair12 = hanalysis::HDoublet(Jets[1], Jets[2]);
    HiggsTagger.FillBranch(HiggsPair12);
    HiggsPair12.SetBdt(HiggsReader.Bdt());
    hanalysis::HDoublet HiggsPair13 = hanalysis::HDoublet(Jets[1], Jets[3]);
    HiggsTagger.FillBranch(HiggsPair13);
    HiggsPair13.SetBdt(HiggsReader.Bdt());
    hanalysis::HDoublet HiggsPair23 = hanalysis::HDoublet(Jets[2], Jets[3]);
    HiggsTagger.FillBranch(HiggsPair23);
    HiggsPair23.SetBdt(HiggsReader.Bdt());

    hanalysis::HDoublet Top0 = hanalysis::HDoublet(Jets[0], Leptons[0]);
    LeptonicTopTagger.GetBranch(Top0);
    Top0.SetBdt(TopReader.Bdt());
    hanalysis::HDoublet Top1 = hanalysis::HDoublet(Jets[1], Leptons[0]);
    LeptonicTopTagger.GetBranch(Top1);
    Top1.SetBdt(TopReader.Bdt());
    hanalysis::HDoublet Top2 = hanalysis::HDoublet(Jets[2], Leptons[0]);
    LeptonicTopTagger.GetBranch(Top2);
    Top2.SetBdt(TopReader.Bdt());
    hanalysis::HDoublet Top3 = hanalysis::HDoublet(Jets[3], Leptons[0]);
    LeptonicTopTagger.GetBranch(Top3);
    Top3.SetBdt(TopReader.Bdt());

    hanalysis::HDoublet AntiTop0 = hanalysis::HDoublet(Jets[0], Leptons[1]);
    LeptonicTopTagger.GetBranch(AntiTop0);
    AntiTop0.SetBdt(TopReader.Bdt());
    hanalysis::HDoublet AntiTop1 = hanalysis::HDoublet(Jets[1], Leptons[1]);
    LeptonicTopTagger.GetBranch(AntiTop1);
    AntiTop1.SetBdt(TopReader.Bdt());
    hanalysis::HDoublet AntiTop2 = hanalysis::HDoublet(Jets[2], Leptons[1]);
    LeptonicTopTagger.GetBranch(AntiTop2);
    AntiTop2.SetBdt(TopReader.Bdt());
    hanalysis::HDoublet AntiTop3 = hanalysis::HDoublet(Jets[3], Leptons[1]);
    LeptonicTopTagger.GetBranch(AntiTop3);
    AntiTop3.SetBdt(TopReader.Bdt());


    HiggsCpvs.push_back(HHiggsCpv(HiggsPair01, Top2, AntiTop3));
    HiggsCpvs.push_back(HHiggsCpv(HiggsPair01, Top3, AntiTop2));
    HiggsCpvs.push_back(HHiggsCpv(HiggsPair02, Top1, AntiTop3));
    HiggsCpvs.push_back(HHiggsCpv(HiggsPair02, Top3, AntiTop1));
    HiggsCpvs.push_back(HHiggsCpv(HiggsPair03, Top1, AntiTop2));
    HiggsCpvs.push_back(HHiggsCpv(HiggsPair03, Top2, AntiTop1));
    HiggsCpvs.push_back(HHiggsCpv(HiggsPair12, Top0, AntiTop3));
    HiggsCpvs.push_back(HHiggsCpv(HiggsPair12, Top3, AntiTop0));
    HiggsCpvs.push_back(HHiggsCpv(HiggsPair13, Top0, AntiTop2));
    HiggsCpvs.push_back(HHiggsCpv(HiggsPair13, Top2, AntiTop0));
    HiggsCpvs.push_back(HHiggsCpv(HiggsPair23, Top0, AntiTop1));
    HiggsCpvs.push_back(HHiggsCpv(HiggsPair23, Top1, AntiTop0));

    return HiggsCpvs;

}
